; File Name   :	d:\hobby3\elektronik\mikrorechner-akustik-set\MAS.bin
; Base Address:	0000h Range: 0000h - 0400h Loaded length: 0400h

		cpu	z80
		org	0
		di
ANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh 
		cp	0
		jr	z, ANF		; keine Taste
		cp	20h 
		jr	z, VWA		; Vorwarnung
		cp	10h
		jr	z, ATL		; Atomalarm
		cp	8
		jr	z, CHA		; Chemischer Alarm
		cp	4
		jr	z, KATA		; Katastrophenalarm
		cp	2
		jr	z, FEUA		; Feueralarm
VWA:		ld	ix, VWANF
		jr	ANSCHW
ATL:		ld	ix, ATLANF
		jr	ANSCHW
CHA:		ld	ix, CHANF
		jr	ANSCHW
KATA:		ld	ix, KATANF
		jr	ANSCHW
FEUA:		ld	ix, FEUANF
ANSCHW:		exx
		ld	l, (ix+0)	; TAR laden
		exx
WDH:		ld	e, 40h
		ld	d, 0FFh
		ld	h, 1
		ld	c, 0FFh
AN1:		ld	l, h
AN2:		xor	a
		ld	b, c
		out	(c), d
S4:		djnz	$
		out	(c), b
		ld	b, c
S5:		djnz	$
		dec 	l
		jr	nz, AN2
		dec 	c
		ld	a, c
		cp	29h
		jr	z, TON
		dec	e
		jr	nz, AN1
		sla	h
		ld	e, 40h
		jr	AN1
TON:		xor	a
		ld	d, 0FFh
		ld	c, (ix+1)	; Tonlnge laden
PZ2:		ld	e, 4
PZ1:		ld	h, 0C8h
TS3:		ld	b, 29h		; 800 Hz laden
		out	(c), d		; High Ausgabe
TS4:		djnz	$
		ld	b, 29h
		out	(c), b		; Low Ausgabe
TS5:		djnz	$
		dec	h
		jr	nz, VERZ1
		dec	e
		jr	nz, VERZ2	; Schleife fr Tonlnge
		dec	c
		jr	nz, PZ2
		ld	e, 40h
		ld	d, 0FFh
		ld	h, 8
		ld	c, 29h
AB1:		ld	l, h
AB2:		xor	a		; Low laden
		ld	b, c
		out	(c), d
AS4:		djnz	$
		out	(c), b
		ld	b, c
AS5:		djnz	$
		dec 	l		; Periodendauer DEC
		jr	nz, AB2
		inc	c
		jr	z, PAUSE0
		dec	e
		jr	nz, AB1
		srl	h
		ld	e, 40h
		jr	AB1
VERZ2:		nop
		nop
		jr	PZ1
VERZ1:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	TS3
PAUSE0:		exx
		dec	l
		exx
		jp	z, ANF
PAUSE:		ld 	c, (ix+2)	; Pausendauer laden
PPZ2:		ld	e, 4
PPZ1:		ld	h, 0C8h
PS3:		ld	b, 29h
		out	(c), b		; Pausenschleife
PS4:		djnz	$
		ld	b, 29h
		out	(c), b
PS5:		djnz	$		; Pausenschleife
		dec	h
		jr	nz, PS3		; Pausenschleife
		dec	e
		jr	nz, PPZ1	; Pausenschleife
		dec	c
		jr	nz, PPZ2	; Pausenschleife
		jp	WDH
		
VWANF:		db    1
		db 0B1h
		db    0
ATLANF:		db  12h
		db    2
		db    2
CHANF:		db    8
		db    7
		db  0Ch
KATANF:		db    5
		db  1Bh
		db    7
FEUANF:		db    3
		db  0Ch
		db    2
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		
		; org 100h
		
LS0:		di
		ld	ix, LAA		; Liedanfangsadresse laden
LS1:		inc	ix		; LAA erhhen
LANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, LANF
		cp	1
		jr	nz, INT
		ld	ix, LAAS
INT:		ld	iy, TLA
		ld	a, (ix+0)	; Akku mit Wert aus Liedtabelle laden
		cp	0FFh		; Ende der Liedfolge erreicht
		jr	z, LS0
		and	0F0h
		cp	0E0h		; Ende eines Liedes erreicht
		jr	z, LS1
		cp	0F0h
		jr	z, PAUDA
		srl	a
		srl	a
		srl	a
		srl	a
		ld	b, 0
		ld	c, a
		add	iy, bc
		ld	d, 0FFh		; Pegelregister laden
LS7:		ld	a, (ix+0)
		and	0Fh
		ld	c, a
		jr	LS3
PAUDA:		ld	d, 0
		jr	LS7
LS3:		ld	e, (iy+0)
LS2:		xor	a
		ld	b, (iy+0Eh)	; Tonhhenregister laden
		out	(c), d
LS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+0Eh)
LS5:		djnz	$
		ld	a, d
		cp	60h
		jr	z, PEG1
		cp	0
		jr	z, PEG1
		dec	d		; Pegelregister erniedrigen
PEG:		dec	e		; Tonlngenregister erniedrigen
		jr 	nz, LS6
		ld	a, c
		cp	0
		jr	z, LS8
		dec	c
		jr	LS3
LS8:		inc	ix
		jp	INT
LS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	LS2
PEG1:		jr	PEG
TLA:		db  21h
		db  23h
		db  25h
		db  27h
		db  29h
		db  2Ch
		db  2Eh
		db  31h
		db  34h
		db  37h
		db  3Ah
		db  3Eh
		db  41h
		db  49h
		db  42h
		db  3Eh
		db  3Ah
		db  37h
		db  33h
		db  30h
		db  2Dh
		db  2Ah
		db  27h
		db  25h
		db  22h
		db  20h
		db  1Eh
LAA:		db  1Ch
		db  23h		; "Im Mrzen der Bauer ..."
		db  73h
		db  73h
		db 0B3h
		db  93h
		db  93h
		db 0C3h
		db  63h
		db  63h
		db  93h
		db  77h
		db 0EEh
		db  41h		; "Im Wald und auf der Heide ..."
		db  43h
		db  41h
		db  43h
		db  41h
		db  45h
		db  13h
		db 0EEh
		db  23h		; "Auf, auf zum frhlichen Jagen ..."
		db  75h
		db  21h
		db  73h
		db 0B1h
		db 0B1h
		db  77h
		db  23h
		db  71h
		db 0B1h
		db  93h
		db  23h
		db  23h
		db  71h
		db  61h
		db  77h
		db 0EEh
		db  53h		; "Der Mond ist aufgegangen ..."
		db  73h
		db  53h
		db 0A3h
		db  93h
		db  77h
		db  53h
		db 0EEh
		db    1		; "Horch, was kommt von drauen rein ..."
		db  21h
		db  41h
		db  51h
		db  71h
		db  91h
		db  73h
		db 0EEh
		db  23h		; "Es waren 2 Knigskinder ..."
		db 0B3h
		db 0B1h
		db 0B1h
		db 0B3h
		db  93h
		db  95h
		db  75h
		db 0EEh
		db  93h		; "Sah' ein Knab ..."
		db  91h
		db 0C2h
		db 0A0h
		db  91h
		db  73h
		db  71h
		db  75h
		db 0EEh
		db  75h		; "Auf, du junger Wandersmann ..."
		db  21h
		db  73h
		db  93h
		db 0B3h
		db 0B3h
		db 0B7h
		db 0EEh
		db  25h		; "nnchen von Tharau"
		db  41h
		db  23h
		db  23h
		db  73h
		db  73h
		db  95h
		db 0B1h
		db  93h
		db  77h
		db 0FFh
LAAS:		db  21h		; "Die Gedanken sind frei ..."
		db  21h
		db  73h
		db  73h
		db 0B1h
		db  71h
		db  27h
		db 0FFh
		nop

		; org 200h

DLS0:		di
		ld	ix, DLAA	; Liedanfangsadresse laden
DLS1:		inc	ix		; LAA erhhen
DLANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, DLANF
		cp	1
		jr	nz, DINT
		ld	ix, DLAAS
DINT:		ld	iy, DTLA
		ld	a, (ix+0)	; Akku mit Wert aus Liedtabelle laden
		cp	0FFh		; Ende der Liedfolge erreicht
		jr	z, DLS0
		and	0F0h
		cp	0E0h		; Ende des Liedes erreicht
		jr	z, DLS1
		cp	0F0h
		jr	z, DPAUDA
		srl	a
		srl	a
		srl	a
		srl	a
		ld	b, 0
		ld	c, a
		add	iy, bc
		ld	d, 0FFh		; Pegelregister laden
DLS7:		ld	a, (ix+0)
		and	0Fh
		ld	c, a
		jr	DLS3
DPAUDA:		ld	d, 0
		jr	DLS7
DLS3:		ld	e, (iy+0)
DLS2:		xor	a
		ld	b, (iy+0Eh)	; Tonhhenregister laden
		out	(c), d
DLS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+0Eh)
DLS5:		djnz	$
		ld	a, d
		cp	60h
		jr	z, DPEG1
		cp	0
		jr	z, DPEG1
		dec	d		; Pegelregister erniedrigen
DPEG:		dec	e		; Tonlngenregister erniedrigen
		jr	nz, DLS6
		ld	a, c
		cp	0
		jr	z, DLS8
		dec	c
		jr	DLS3
DLS8:		inc	ix
		jp	DINT
DLS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	DLS2
DPEG1:		jr	DPEG
DTLA:		db  21h
		db  23h
		db  25h
		db  27h
		db  29h
		db  2Ch
		db  2Eh
		db  31h
		db  34h
		db  37h
		db  3Ah
		db  3Eh
		db  41h
		db  49h
		db  42h
		db  3Eh
		db  3Ah
		db  37h
		db  33h
		db  30h
		db  2Dh
		db  2Ah
		db  27h
		db  25h
		db  22h
		db  20h
		db  1Eh
DLAA:		db  1Ch
		db  95h		; "Alle Jahre wieder ..."
		db 0B1h
		db  93h
		db  73h
		db  67h
		db  47h
		db 0EEh
		db  21h		; "Am Weihnachtsbaume ..."
		db  21h
		db  61h
		db  93h
		db  61h
		db  91h
		db 0D1h
		db 0B1h
		db  93h
		db  61h
		db 0EEh
		db  45h		; "Bald nun ist Weihnachtszeit..."
		db  21h
		db    3
		db  73h
		db  73h
		db  73h
		db  75h
		db  91h
		db  63h
		db  77h
		db 0EEh
		db  41h		; "Guten Abend, schn' Abend..."
		db  41h
		db  93h
		db  83h
		db  63h
		db  43h
		db  93h
		db  13h
		db  43h
		db 0B3h
		db  83h
		db  97h
		db 0EEh
		db  91h		; "Ihr Kinderlein, kommet..."
		db  93h
		db  61h
		db  91h
		db  93h
		db  61h
		db  91h
		db  73h
		db  41h
		db  71h
		db  63h
		db 0EEh
		db  77h		; "Vorfreude, ..."
		db  43h
		db    3
		db  95h
		db  91h
		db  73h
		db  43h
		db 0EEh
		db  73h		; "Morgen, Kinder, ..."
		db  23h
		db  43h
		db  23h
		db  41h
		db  71h
		db  61h
		db  91h
		db  73h
		db  23h
		db 0EEh
		db  93h		; "Lat uns froh und munter sein"
		db  93h
		db  91h
		db  81h
		db  91h
		db  71h
		db  63h
		db  63h
		db  63h
		db 0EEh
		db  97h		; "Oh, du frhlich ..."
		db  0B7h
		db  95h
		db  71h
		db  63h
		db  73h
		db 0FFh
DLAAS:		db  63h		; "Sind die Lichter angezndet ..."
		db  71h
		db  93h
		db  91h
		db  73h
		db  61h
		db  43h
		db  41h
		db 0FFh
		
		; org 300h
		
RLS0:		di
RLANF:		ld	a, (8000h)	; Tastenabfrage
		and	3Fh
		cp	0
		jr	z, RLANF
		cp	20h
		jr	nz, NEXT1
		ld	ix, RLAA1
		jr	RLS1
NEXT1:		cp	10h
		jr	nz, NEXT2
		ld	ix, RLAA2
		jr	RLS1
NEXT2:		cp	8
		jr	nz, NEXT3
		ld	ix, RLAA3
		jr	RLS1
NEXT3:		cp	4
		jr	nz, NEXT4
		ld	ix, RLAA4
		jr	RLS1
NEXT4:		cp	2
		jr	nz, NEXT5
		ld	ix, RLAA5
		jr	RLS1
NEXT5:		ld	ix, RLAA6
RLS1:		inc	ix		; LAA erhhen
RINT:		ld	iy, RTLA
		ld	a, (ix+0)	; Akku mit Wert aus Rufzeichentabelle
		cp	0FFh		; Ende der Rufzeichenfolge erreicht
		jr	z, RLS0
		and	0F0h
		cp	0E0h		; Ende eines Rufzeichens erreicht
		jr	z, RLS1
		cp	0F0h
		jr	z, RPAUDA
		srl	a
		srl	a
		srl	a
		srl	a
		ld	d, 0FFh		; Pegelregister laden
RLS7:		ld	a, (ix+0)
		and	0Fh
		ld	c, a
		jr	RLS3
RPAUDA:		ld	d, 0
		jr	RLS7
RLS3:		ld	e, (iy+0)
RLS2:		xor	a
		ld	b, (iy+1)	; Tonhhenregister laden
		out	(c), d		; Pegelregisterausgabe
RLS4:		djnz	$
		out	(c), b		; 0-Pegel-Ausgabe
		ld	b, (iy+1)
RLS5:		djnz	$
RPEG:		dec	e		; Tonlngenregister erniedrigen
		jr	nz, RLS6
		ld	a, c
		cp	0
		jr	z, RLS9
		dec	c
		jr	RLS3
RLS9:		ld	a, d
		cp	0
		jr	z, RLS8
		ld	d, 0
		ld	c, 0
		jr	RLS3
RLS8:		inc	ix
		jp	RINT
RLS6:		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jr	RLS2
		jr	RPEG
RTLA:		db  49h
RLAA1:		db  1Ch
		db    0		; "SOS"
		db    0
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db 0F0h
		db    0
		db    0
		db    0
		db 0F4h
RLAA2:		db 0FFh
		db    1		; "CQ, CQ" - allgemeiner Anruf
		db    0
		db    1
		db    0
		db 0F0h
		db    1
		db    1
		db    0
		db    1
		db 0F4h
RLAA3:		db 0FFh
		db    1		; "99" - Rume den Kanal!
		db    1
		db    1
		db    1
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db    1
		db    0
		db 0F4h
RLAA4:		db 0FFh
		db    1		; "88" - Liebe und Ksse
		db    1
		db    1
		db    0
		db    0
		db 0F0h
		db    1
		db    1
		db    1
		db    0
		db    0
		db 0F4h
RLAA5:		db 0FFh
RLAA6:		db 0FFh

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
; end of "ROM"

		end
